﻿using UnityEngine;
using System.Collections;

public class GameManager : MonoBehaviour 
{
    float currentExponent = 0;
    public GameObject[] players;
    public GameObject[] textCallouts;
    public int count = 0;
	// Use this for initialization
	void Start () 
    {
        GameObject txt = Instantiate(textCallouts[0], Vector3.zero, Quaternion.identity) as GameObject;
        Destroy(txt, 3);
        NewLevel(true);
	}
	
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.Escape))
            Application.Quit();
    }

    public void NewLevel(bool firstRun)
    {
        count++;
        currentExponent = Mathf.Pow(2, count);

        if(!firstRun)
        {
            GameObject[] txts = GameObject.FindGameObjectsWithTag("txt");
            foreach(GameObject t in txts)
            {
                if (t != null)
                    Destroy(t);
            }
            DestroyAllSprites();
        }
        Invoke("SpawnPlayers", 3f);
        GameObject expTxt = Instantiate(textCallouts[1], Vector3.zero, Quaternion.identity) as GameObject;
        expTxt.GetComponent<TextMesh>().text = "exponent: " + currentExponent.ToString();
        Destroy(expTxt, 3);
    }

    void SpawnPlayers()
    {
        Instantiate(players[0], Vector3.zero, Quaternion.identity);
        for(int i = 0; i<currentExponent-1; i++)
        {
            Instantiate(players[1], Vector3.zero, Quaternion.identity);
        }
    }

    void DestroyAllSprites()
    {
        GameObject[] sprites = GameObject.FindGameObjectsWithTag("s");
        foreach(GameObject s in sprites)
        {
            if (s != null)
                Destroy(s);
        }
    }

    public void GameOver()
    {
        DestroyAllSprites();
        Instantiate(textCallouts[2], Vector3.zero, Quaternion.identity);
        Invoke("ReloadGame", 2f);
    }

    void ReloadGame()
    {
        Application.LoadLevel(Application.loadedLevel);
    }
}
