﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour 
{
    Vector3 direction = Vector3.zero;
    public float acceleration = 1.0f;
    public float maxSpeed = 0.2f;
    public float rotSpeed = 1.0f;
    public bool debugPlayer = false;
    public Vector3 ambientForce;
    public float forceRange = 0.2f;
    public float maxChangeRate = 5f;
    public GameObject wasdTxt;
    GameManager gm;

    void Awake()
    {
        gm = Camera.main.GetComponent<GameManager>();
        if (gm.count > 1)
            wasdTxt.SetActive(false);
    }

    void Start()
    {
        InvokeRepeating("ChangeDirection", 0, Random.Range(1f, maxChangeRate));
    }

	void Update () 
    {
        Control();
        gameObject.transform.Rotate(Vector3.up*rotSpeed);
        if (debugPlayer)
            gameObject.GetComponent<SpriteRenderer>().color = Color.red;
	}

    float horz = 0;
    float vert = 0;
    void Control()
    {
        horz = Input.GetAxis("Horizontal");
        vert = Input.GetAxis("Vertical");
        direction = Vector3.Lerp(direction, new Vector3(horz, vert, 0), acceleration*Time.deltaTime);
        gameObject.transform.position += Vector3.ClampMagnitude(direction + ambientForce, maxSpeed);
    }

    void OnBecameInvisible()
    {
        gameObject.transform.position = -gameObject.transform.position;
    }

    void ChangeDirection()
    {
        ambientForce = new Vector3(Random.Range(-forceRange, forceRange), Random.Range(-forceRange, forceRange), 0);
    }

    void OnMouseDown()
    {
        gm.NewLevel(false);
    }
}
